/*
 * EJS Embedded JavaScript templates
 * Copyright 2112 Matthew Eernisse (mde@fleegix.org)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
*/

exports.escapeRegExpChars = (function () {
  var specials = [ '^', '$', '/', '.', '*', '+', '?', '|', '(', ')',
      '[', ']', '{', '}', '\\' ];
  var sRE = new RegExp('(\\' + specials.join('|\\') + ')', 'g');
  return function (string) {
    var str = string || '';
    str = String(str);
    return str.replace(sRE, '\\$1');
  };
})();

exports.escapeXML = function (markup) {
  var chars = {
        '&': '&amp;'
      , '<': '&lt;'
      , '>': '&gt;'
      , '"': '&quot;'
      , '\'': '&#39;'
    }
  , str = String(markup);
  Object.keys(chars).forEach(function (k) {
    str = str.replace(new RegExp(k, 'g'), chars[k]);
  });
  return str;
};

exports.shallowCopy = function (to, from) {
  for (var p in from) {
    to[p] = from[p];
  }
  return to;
};

